#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
string abe="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
int kojeslovo(char c)
{
    for(int i=0;i<26;i++)
        if(c==abe[i]) return i+1;
}
ll faktorijel(ll n,ll m)
{
   ll rez=1;
   while(n>m){
       rez*=n;
       n--;
   }
   return rez;
}
int main()
{
    ll n;
    cin >> n;
    char c;
    string s="";
    for(int i=0;i<n;i++)
    {
        cin >> c;
        s.push_back(c);
    }
    ll m=n;
    ll a[27]={0};
    for(ll i=0;i<n;i++)
    {
        if( i!=0 && a[kojeslovo(s[i])]!= a[kojeslovo(s[i-1])]&&
          a[kojeslovo(s[i])]!=0) m--;
        else
        a[kojeslovo(s[i])]++;
    }
    ll rez=0,res=0, pom=0;
    for(ll i=1;i<27;i++)
    {
        if(a[i]>1) {
          pom+=a[i];
          rez+=a[i]-1;
        }
        if(a[i]==0) res=-1;
    }
    ll pr=pow(10,9)+7;
    if(m-rez+1<26 || res == -1 )
        cout << 0 << '\n';
     else cout << faktorijel(pom,rez+(n-m)) %pr <<  '\n' ;
    return 0;
}